<?php

/**
 * modificacion_retefuente actions.
 *
 * @package    nomina
 * @subpackage modificacion_retefuente
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class modificacion_retefuenteActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_MODIFICA_RETEFUENTE',
        'NO_DATOS_FUNCIONARIO_V',
        'NO_CONCEP_NOMINA',
        'NO_PERIODO',
        'NO_TIPO_PERIODO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'id_tipo_doc' => 'NO_MODIFICA_RETEFUENTE',
            'num_doc' => 'NO_MODIFICA_RETEFUENTE'
        ),
        'NO_CONCEP_NOMINA' =>
        array(
            'id_concep_nomina' => 'NO_MODIFICA_RETEFUENTE'
        ),
        'NO_PERIODO' =>
        array(
            'id_periodo' => 'NO_MODIFICA_RETEFUENTE'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'id_tipo_periodo' => 'NO_PERIODO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_MODIFICA_RETEFUENTE' =>
        array(
            'id_modifica_retefuente' => 'id_modifica_retefuente',
            'id_periodo' => 'id_periodo',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'id_concep_nomina' => 'id_concep_nomina',
            'fecha' => 'fecha',
            'observaciones' => 'observaciones',
            'porcentaje' => 'porcentaje'
        ),
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'nombre_completo' => 'nombre_completo'
        ),
        'NO_CONCEP_NOMINA' =>
        array(
            'codigo' => 'codigo_concepto',
            'descripcion' => 'descripcion_concepto',
            'codigo,||, - ,||,descripcion' => 'completo_concepto'
        ),
        'NO_PERIODO' =>
        array(
            'id_meses' => 'id_meses',
            'id_anhos' => 'id_anhos'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'descripcion' => 'descripcion_periodo'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_MODIFICA_RETEFUENTE' => array(
            'id_modifica_retefuente,a' => array('!=' => array(-1)),
            'id_modifica_retefuente,b' => array('=' => array('id_modifica_retefuente')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'num_doc' => array('=' => array('num_doc')),
            'id_concep_nomina' => array('=' => array('id_concep_nomina')),
            'id_periodo' => array('=' => array('id_periodo_filtro')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'num_doc'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_modifica_retefuente'; //identificador de la tabla
    protected $id_names = array('id_modifica_retefuente'); //llave primaria
    protected $field_names = array('id_periodo', 'id_tipo_doc', 'num_doc', 'id_concep_nomina', 'porcentaje', 'fecha', 'observaciones'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_MODIFICA_RETEFUENTE'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD
    protected $campo_fecha_sistema = array(
        'fecha'
    );


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_modifica_retefuente'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $sql = "select id_concep_rete from no_param_concep where id_param_concep = 1";
            $results = CN_TABLE::executeSQL($sql);

            $id_concep_rete = $results[0]['id_concep_rete'];
            $request['id_concep_nomina'] = $id_concep_rete;
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_tipo_doc = $list_data_post[0]['id_tipo_doc'];
                $num_doc = $list_data_post[0]['num_doc'];
                $fecha = $list_data_post[0]['fecha'];
                $id_periodo = $list_data_post[0]['id_periodo'];
                $id_concep_nomina = $list_data_post[0]['id_concep_nomina'];
                $porcentaje = $list_data_post[0]['porcentaje'];

                $sql = <<<EOD
SELECT * FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo 
EOD;
                $parametros = CN_TABLE::executeSQL($sql);
                $id_anhos = $parametros[0]['id_anhos'];
                $id_meses = $parametros[0]['id_meses'];
                $id_periodo = $parametros[0]['id_periodo'];
                $id_tipo_periodo = $parametros[0]['id_tipo_periodo'];
                $fecha_ini = $parametros[0]['fecha_ini'];
                $fecha_fin = $parametros[0]['fecha_fin'];

                $sql = <<<EOD
SELECT * FROM NO_TIPO_PERIODO WHERE ID_TIPO_PERIODO = $id_tipo_periodo 
EOD;
                $results = CN_TABLE::executeSQL($sql);

                $num_dias = $results[0]['no_dias_mes'];

                $sql = <<<EOD
SELECT * FROM NO_CONCEPTO_FUNC 
    WHERE ID_TIPO_DOC = $id_tipo_doc and NUM_DOC = $num_doc AND ID_CONCEP_NOMINA = $id_concep_nomina  
        and estado = 1 and actual = 1  
EOD;
                $results = CN_TABLE::executeSQL($sql);

                /**
                 * Verifica que existe en NO_CONCEPTO_FUNC, estado = 1 y actual = 1  - 20150213
                 */
                if (count($results) > 0) {

                    $sql = <<<EOD
UPDATE NO_CONCEPTO_FUNC SET PORCENTAJE = $porcentaje 
    WHERE ID_TIPO_DOC = $id_tipo_doc and NUM_DOC = $num_doc AND ID_CONCEP_NOMINA = $id_concep_nomina 
EOD;
                    $this->conn->execute($sql);

                    $sql = <<<EOD
UPDATE NO_CONCEPTO_PERIODO SET PORCENTAJE = $porcentaje 
    WHERE ID_TIPO_DOC = $id_tipo_doc and NUM_DOC = $num_doc AND ID_CONCEP_NOMINA = $id_concep_nomina AND PERIODO = $id_periodo 
EOD;
                    $this->conn->execute($sql);
                } else {

                    $sql = <<<EOD
INSERT INTO NO_CONCEPTO_FUNC (ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,PORCENTAJE,ESTADO,ACTUAL,FECHA_DESDE)
    VALUES($id_tipo_doc,$num_doc,$id_concep_nomina,$porcentaje,1,1,to_date('$fecha_ini','YYYY-MM-DD'))
EOD;
                    $this->conn->execute($sql);

                    $sql = <<<EOD
INSERT INTO NO_CONCEPTO_PERIODO (ID_ANHOS,ID_MESES,PERIODO,ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,FECHA_DESDE,FECHA_HASTA,PORCENTAJE,NUM_DIAS)
    VALUES($id_anhos,$id_meses,$id_periodo,$id_tipo_doc,$num_doc,$id_concep_nomina,
        to_date('$fecha_ini','YYYY-MM-DD'),last_day(to_date('$fecha_ini','YYYY-MM-DD')),$porcentaje,$num_dias)
EOD;
                    $this->conn->execute($sql);
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }


        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
